package eu.jonahbauer.raytracing.render;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Objects;

import static org.junit.jupiter.api.Assertions.assertEquals;

class ImageTest {

    @Test
    void test(@TempDir Path dir) throws IOException {
        var image = new Image(256, 256);

        for (var y = 0; y < image.height(); y++) {
            for (var x = 0; x < image.width(); x++) {
                var r = (double) x / (image.width() - 1);
                var g = (double) y / (image.height() - 1);
                var b = 0;

                image.set(x, y, r, g, b);
            }
        }

        System.out.println(dir);
        ImageIO.write(image, dir.resolve("img.ppm"));

        String expected;
        String actual;

        try (var in = Objects.requireNonNull(ImageTest.class.getResourceAsStream("simple_image.ppm"))) {
            expected = new String(in.readAllBytes(), StandardCharsets.US_ASCII);
        }

        try (var in = Files.newInputStream(dir.resolve("img.ppm"))) {
            actual = new String(in.readAllBytes(), StandardCharsets.US_ASCII);
        }

        assertEquals(expected, actual);
    }

}